#
# spec file for package perl-DBIx-Class-DeploymentHandler
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           perl-DBIx-Class-DeploymentHandler
Version:        0.002233
Release:        1.17
%define cpan_name DBIx-Class-DeploymentHandler
Summary:        Extensible DBIx::Class deployment
License:        Artistic-1.0 OR GPL-1.0-or-later
Group:          Development/Libraries/Perl
Url:            https://metacpan.org/release/%{cpan_name}
Source0:        https://cpan.metacpan.org/authors/id/M/MM/MMCCLIMON/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(Carp::Clan)
BuildRequires:  perl(Context::Preserve) >= 0.01
BuildRequires:  perl(DBD::SQLite) >= 1.35
BuildRequires:  perl(DBIx::Class) >= 0.08121
BuildRequires:  perl(Log::Contextual) >= 0.005005
BuildRequires:  perl(Module::Runtime) >= 0.001
BuildRequires:  perl(Moose) >= 1
BuildRequires:  perl(MooseX::Role::Parameterized) >= 0.18
BuildRequires:  perl(Path::Class) >= 0.26
BuildRequires:  perl(SQL::SplitStatement) >= 1.00020
BuildRequires:  perl(SQL::Translator) >= 0.11005
BuildRequires:  perl(Sub::Exporter::Progressive)
BuildRequires:  perl(Test::Fatal) >= 0.006
BuildRequires:  perl(Test::More) >= 0.88
BuildRequires:  perl(Test::Requires) >= 0.06
BuildRequires:  perl(Text::Brew) >= 0.02
BuildRequires:  perl(Try::Tiny)
BuildRequires:  perl(YAML) >= 0.66
BuildRequires:  perl(aliased)
BuildRequires:  perl(autodie)
BuildRequires:  perl(namespace::autoclean)
BuildRequires:  perl(parent) >= 0.225
Requires:       perl(Carp::Clan)
Requires:       perl(Context::Preserve) >= 0.01
Requires:       perl(DBIx::Class) >= 0.08121
Requires:       perl(Log::Contextual) >= 0.005005
Requires:       perl(Module::Runtime) >= 0.001
Requires:       perl(Moose) >= 1
Requires:       perl(MooseX::Role::Parameterized) >= 0.18
Requires:       perl(Path::Class) >= 0.26
Requires:       perl(SQL::SplitStatement) >= 1.00020
Requires:       perl(SQL::Translator) >= 0.11005
Requires:       perl(Sub::Exporter::Progressive)
Requires:       perl(Text::Brew) >= 0.02
Requires:       perl(Try::Tiny)
Requires:       perl(YAML) >= 0.66
Requires:       perl(autodie)
Requires:       perl(namespace::autoclean)
Requires:       perl(parent) >= 0.225
%{perl_requires}
# MANUAL BEGIN
BuildRequires:  perl(YAML)
# MANUAL END

%description
'DBIx::Class::DeploymentHandler' is, as its name suggests, a tool for
deploying and upgrading databases with DBIx::Class. It is designed to be
much more flexible than DBIx::Class::Schema::Versioned, hence the use of
Moose and lots of roles.

'DBIx::Class::DeploymentHandler' itself is just a recommended set of roles
that we think will not only work well for everyone, but will also yield the
best overall mileage. Each role it uses has its own nuances and
documentation, so I won't describe all of them here, but here are a few of
the major benefits over how DBIx::Class::Schema::Versioned worked (and
DBIx::Class::DeploymentHandler::Deprecated tries to maintain compatibility
with):

  * Downgrades in addition to upgrades.

  * Multiple sql files files per upgrade/downgrade/install.

  * Perl scripts allowed for upgrade/downgrade/install.

  * Just one set of files needed for upgrade, unlike before where one might
need to generate 'factorial(scalar @versions)', which is just silly.

  * And much, much more!

That's really just a taste of some of the differences. Check out each role
for all the details.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%check
make test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes README TODO
%license LICENSE

%changelog
* Thu Sep 26 2019 <timueller+perl@suse.de>
- updated to 0.002233
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002233  2019-09-25 13:32:11-04:00 America/New_York
  - Add txn_wrap attribute to DBIC::DeploymentHandler
  - Bugfix: Do not remove "false" transactions in deploy()
  - use SQL::SplitStatement to split SQL statements in DDLs
  - Add txn_prep attribute to keep backwards-compatibility
  - Fixes GH #47, #68, #72 - thanks @augenslat
* Fri Jun  7 2019 Stephan Kulow <coolo@suse.com>
- updated to 0.002232
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002232  2019-06-06 21:49:17-04:00 America/New_York
  - Add missing dependency on YAML.pm
* Sat May 11 2019 Stephan Kulow <coolo@suse.com>
- updated to 0.002231
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002231  2019-05-10 09:28:36-04:00 America/New_York
  - Revert conversion to Moo; this code is now identical to v0.002224, with one
    small fix from 0.002225, having to do with Pg chunk-splitting when there
    is no semicolon
* Wed Apr  3 2019 Stephan Kulow <coolo@suse.com>
- updated to 0.002230
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002230  2019-03-14 18:31:07+00:00 Europe/London
  - MooX::Role::Parameterized forces min perl 5.010
  0.002229  2019-03-14 18:13:25+00:00 Europe/London
  - convert from Package::Variant to MooX::Role::Parameterized - fix #67
  0.002228  2019-03-14 07:13:33+00:00 Europe/London
  - IO::All dep to 0.87 in case causing Win32 problem
* Wed Mar 13 2019 Stephan Kulow <coolo@suse.com>
- updated to 0.002227
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002227  2019-03-11 05:58:07+00:00 Europe/London
  - test version-objects in 5.8-10 compatible way
  0.002226  2019-03-11 03:14:04+00:00 Europe/London
  - relax the Pg chunk-splitting when no ";"
  - better test of version-object on schema
  0.002225  2019-03-11 01:56:47+00:00 Europe/London
  - convert to Type::Tiny
  - Port to Moo
  - convert parameterised role to Package::Variant
  - convert file-handling to IO::All
  0.002224  2019-03-09 05:16:47+00:00 Europe/London
  - binmode on all filehandles so lines always end LF - thanks @wchristian
  - more sophisticated SQL parsing handles Pg $$ stuff - thanks @mrenvoize
    for report
  0.002223  2019-03-07 01:36:36+00:00 Europe/London
  - handle "package NAME VERSION" in a DBIx::Class::Schema - $VERSION
    will be object
  - add needed dep - thanks @wheinze
* Tue Jan  9 2018 coolo@suse.com
- updated to 0.002222
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002222  2018-01-06 10:25:42-08:00 America/Los_Angeles
  - Stop defaulting to include DROP TABLE, introduced by fix in prior release
    (Fixes GH#59, thanks for the report Eugen Konkov!)
* Mon Oct 16 2017 coolo@suse.com
- updated to 0.002221
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002221  2017-09-27 21:19:42-04:00 America/New_York
  - Allow easy changing the version storage table name, which makes subclassing
    much less painful (Thanks Andrew Gregory!)
  - Fix args passed to SQL::Translator::Diff
  - Add Michael McClimon as comaint
  0.002220  2017-08-29 16:59:10-07:00 America/Los_Angeles
  - generate short package names for scripts (Fixes GH#55)
    (Thanks Andrew Gregory!)
  - Fix args to internal method (Fixes GH#53)
    (Thanks Alastair McGowan-Douglas!)
  - Allow schema versions to be version objects (Fixes GH#51)
    (Good find Jonathan Scott Duff!)
* Tue Mar 21 2017 coolo@suse.com
- updated to 0.002219
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002219  2017-03-19 21:15:19-07:00 America/Los_Angeles
  - Fix typo in docs (Thanks Aaron Crane) (Fixes GH#49)
  - Fix spelling mistake in POD (Thanks Stefan Hornburg!)
  - Add links to ::Intro from the docs (Thanks Martin Renvoize!)
* Tue Nov  3 2015 coolo@suse.com
- updated to 0.002218
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002218  2015-10-31 16:35:26-07:00 America/Los_Angeles
  - Fix spelling mistake in POD (Thanks Gregor Herrmann!)
* Mon Oct  5 2015 coolo@suse.com
- updated to 0.002217
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002217  2015-10-04 15:05:01-07:00 America/Los_Angeles
  - Document Custom Script Helper pattern
* Mon Jun 15 2015 coolo@suse.com
- updated to 0.002216
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002216  2015-06-14 09:34:57-07:00 America/Los_Angeles
  - Use Pod::Weaver::Plugin::Ditaa to render diagram
* Wed Apr 15 2015 coolo@suse.com
- updated to 0.002215
  see /usr/share/doc/packages/perl-DBIx-Class-DeploymentHandler/Changes
  0.002215  2015-01-10 13:58:10-06:00 America/Chicago
  - Improve documentation for how to portably create indices
    (Thanks Meredith Howard for the ideas!)
  0.002214  2014-12-21 11:53:20-06:00 America/Chicago
  - Fix inconsistency of what files get run when `ignore_ddl` is set.
    To be clear, if in the past you generated DDL and *also* hand wrote DDL,
    `ignore_ddl` would ignore both, though the intention was only to ignore
    generated DDL.
    (Thanks Lianna Eeftinck for very detailed bug report at GH#20!)
  - Include the filename of the script being run in case of error
  - Add some documentation for how to portably create indices
  - Fix doc bug stating that install calls initialize
    (Thanks Gavin Shelley! Fixes GH#13)
  - Minor Pod Fixes (Thanks Renee B and Pär Karlsson!)
  0.002213  2014-12-03 08:44:10-06:00 America/Chicago
  - Fix some POD formatting
  0.002212  2014-10-11 15:04:22-05:00 America/Chicago
  - Add some nice documentation on overall structure
  0.002211  2014-05-15 20:06:48-05:00 America/Chicago
  - Fix some missing ABSTRACTs (Fixes GH#22, thanks Gregor Herrmann!)
* Wed Apr  2 2014 coolo@suse.com
- updated to 0.002210
* Mon Mar 31 2014 coolo@suse.com
- regenerate with uptodate cpanspec
* Fri Mar 28 2014 alarrosa@suse.com
- Fixed the license in the spec file and added a version number to the
  perl-Log-Contextual build dependency
* Mon Mar 17 2014 alarrosa@suse.com
- initial package 0.002210
  * created by cpanspec 1.78.07
